#ifndef TARTCANVASMANAGER_HH
#define TARTCANVASMANAGER_HH

#include "TObject.h"

class TCanvas;
class TPad;
class TVirtualPad;

class TNadekoCanvasManager
{
public:
  static void SetLogx(Int_t value);
  static void SetLogy(Int_t value);
  static void SetLogz(Int_t value);

  static TCanvas* GetCanvas();
  static TCanvas* GetCanvas(Int_t id);
  static Int_t GetSubpadNumber();
  static TObject* GetObject(TClass* classpt);
  static void SetWindowSize(UInt_t ww, UInt_t wh);
  static void Divide(Int_t nx = 1, Int_t ny = 1,
		     Float_t xmargin = 0.01, Float_t ymargin = 0.01, Int_t color = 0);

  static TVirtualPad* cd(Int_t subpadnumber = 0);
  static TVirtualPad* cdNext();
  static TVirtualPad* cdPrev();

  static void SaveAs(char* filename = "", Option_t* option = "");
};

#endif
