
#include "TNadekoAlias.hh"
#include "TNadekoHistManager.hh"
#include "TNadekoCanvasManager.hh"
#include "TNadekoSimpleFunction.hh"
#include "TNadekoExec.hh"

void fetch(char* filename){TNadekoHistManager::ReadHist(filename);}
void hstore(char* filename){TNadekoHistManager::WriteHist(filename);}
void clear(){TNadekoHistManager::DeleteHist();}
void hdel(int id){TNadekoHistManager::DeleteHist(id);}
void hdel(int idstart, int idend){TNadekoHistManager::DeleteHist(idstart, idend);}

void ls(){TNadekoHistManager::PrintListOfHist();}

void ht(int idstart, int idend){cd(1);hht(idstart, idend);}
void ht(int id){cdn();hht(id);}
void htp(){cdn();hhtp();}
void hn(){cdn();hhn();}
void hb(){cdn();hhb();}

void hht(int idstart, int idend)
{for(int i = idstart; i <= idend && i-idstart < TNadekoCanvasManager::GetSubpadNumber(); ++i)
    {hht(i);cdn();}}
void hht(int id){TNadekoHistManager::DrawHist(id);}
void hhtp(){TNadekoHistManager::DrawCurrentHist();}
void hhn(){TNadekoHistManager::DrawNextHist();}
void hhb(){TNadekoHistManager::DrawPreviousHist();}

void lg(){lgx();lgy();lgz();}
void ln(){lnx();lny();lnz();}
void lgx(){TNadekoCanvasManager::SetLogx(1);}
void lgy(){TNadekoCanvasManager::SetLogy(1);}
void lgz(){TNadekoCanvasManager::SetLogz(1);}
void lnx(){TNadekoCanvasManager::SetLogx(0);}
void lny(){TNadekoCanvasManager::SetLogy(0);}
void lnz(){TNadekoCanvasManager::SetLogz(0);}

void size(UInt_t ww, UInt_t wh){TNadekoCanvasManager::SetWindowSize(ww, wh);}
void cd(Int_t subpadnumber){TNadekoCanvasManager::cd(subpadnumber);}
void cdn(){TNadekoCanvasManager::cdNext();}
void cdb(){TNadekoCanvasManager::cdPrev();}
void zone(Int_t nx, Int_t ny, Float_t xmargin, Float_t ymargin, Int_t color)
{TNadekoCanvasManager::Divide(nx, ny, xmargin, ymargin, color);}

Double_t xval(){return TNadekoExec::GXValue();}
Double_t yval(){return TNadekoExec::GYValue();}
void xyval(){Double_t x,y;TNadekoExec::GXYValue(x,y);}
void zoom(){TNadekoSimpleFunction::GRange();}
void unzoom(){TNadekoSimpleFunction::Range();}
void blow(){TNadekoSimpleFunction::GBlow();}
void hsta(){TNadekoSimpleFunction::StatusHist();}
void xsta(){TNadekoSimpleFunction::GStatusX();}
void cpro(){TNadekoSimpleFunction::CutGHist();}
TFitResultPtr xfitp(int n){return TNadekoSimpleFunction::GFitPolynomial(n);}
TFitResultPtr xfite(){return TNadekoSimpleFunction::GFitExponential();}
TFitResultPtr xfitg(){return TNadekoSimpleFunction::GFitGaussian();}
TFitResultPtr xfitl(){return TNadekoSimpleFunction::GFitLandau();}

void figa(){fitg();}
TFitResultPtr fit(const char* formula, Option_t* option, Option_t* goption, Double_t xmin, Double_t xmax){return TNadekoSimpleFunction::Fit(formula, option, goption, xmin, xmax);}
TFitResultPtr fitp(int n, Double_t xmin, Double_t xmax, Option_t* option, Option_t* goption){return TNadekoSimpleFunction::FitPolynomial(n, option, goption, xmin, xmax);}
TFitResultPtr fite(Double_t xmin,  Double_t xmax, Option_t* option, Option_t* goption){return TNadekoSimpleFunction::FitExponential(option, goption, xmin, xmax);}
TFitResultPtr fitg(Double_t xmin,  Double_t xmax, Option_t* option, Option_t* goption){return TNadekoSimpleFunction::FitGaussian(option, goption, xmin, xmax);}
TFitResultPtr fitl(Double_t xmin,  Double_t xmax, Option_t* option, Option_t* goption){return TNadekoSimpleFunction::FitLandau(option, goption, xmin, xmax);}

void chbin(Int_t ngroupx, Int_t ngroupy, Int_t ngroupz){TNadekoSimpleFunction::ChangeBin(ngroupx, ngroupy, ngroupz);}

void pfx(){TNadekoSimpleFunction::ProfileX();}
void pfy(){TNadekoSimpleFunction::ProfileY();}
void prx(){TNadekoSimpleFunction::ProjectionX();}
void pry(){TNadekoSimpleFunction::ProjectionY();}
void slx(Int_t num){TNadekoSimpleFunction::SliceX(num);}
void sly(Int_t num){TNadekoSimpleFunction::SliceY(num);}
void bnx(double firstx, double lastx, Option_t* option){TNadekoSimpleFunction::BanX(firstx, lastx, option);}
void bny(double firsty, double lasty, Option_t* option){TNadekoSimpleFunction::BanY(firsty, lasty, option);}
void blowxyz(double firstx, double lastx, double firsty, double lasty, double firstz, double lastz)
{TNadekoSimpleFunction::Blow(firstx, lastx, firsty, lasty, firstz, lastz);}
void blowx(double firstx, double lastx){TNadekoSimpleFunction::BlowX(firstx, lastx);}
void blowy(double firsty, double lasty){TNadekoSimpleFunction::BlowY(firsty, lasty);}
void blowz(double firstz, double lastz){TNadekoSimpleFunction::BlowZ(firstz, lastz);}

void mami(double min, double max){TNadekoSimpleFunction::MinMax(min, max);}

void scale(Double_t c){TNadekoSimpleFunction::Scale(c);}
void add(Int_t id1, Int_t id2, Double_t c1, Double_t c2){TNadekoSimpleFunction::Add(id1, id2, c1, c2);}
void multiply(Int_t id1, Int_t id2, Double_t c1, Double_t c2){TNadekoSimpleFunction::Multiply(id1, id2, c1, c2);}
void divide(Int_t id1, Int_t id2, Double_t c1, Double_t c2){TNadekoSimpleFunction::Divide(id1, id2, c1, c2);}

void print(char* filename, Option_t* option){TNadekoCanvasManager::SaveAs(filename, option);}

TH1* fillhist(const char* name, const char* title,
	      Double_t valx, Int_t nbinsx, Double_t xlow, Double_t xup)
{return TNadekoSimpleFunction::CreateAndFillHist(name, title,
					      valx, nbinsx, xlow, xup);}
TH2* fillhist(const char* name, const char* title,
	      Double_t valx, Int_t nbinsx, Double_t xlow, Double_t xup,
	      Double_t valy, Int_t nbinsy, Double_t ylow, Double_t yup)
{return TNadekoSimpleFunction::CreateAndFillHist(name, title,
					      valx, nbinsx, xlow, xup,
					      valy, nbinsy, ylow, yup);}
TH3* fillhist(const char* name, const char* title,
	      Double_t valx, Int_t nbinsx, Double_t xlow, Double_t xup,
	      Double_t valy, Int_t nbinsy, Double_t ylow, Double_t yup,
	      Double_t valz, Int_t nbinsz, Double_t zlow, Double_t zup)
{return TNadekoSimpleFunction::CreateAndFillHist(name, title,
					      valx, nbinsx, xlow, xup,
					      valy, nbinsy, ylow, yup,
					      valz, nbinsz, zlow, zup);}
TH1* fillhist(const char* name, const char* title, Int_t size,
	      Double_t* valx, Int_t nbinsx, Double_t xlow, Double_t xup)
{return TNadekoSimpleFunction::CreateAndFillHist(name, title, size,
					      valx, nbinsx, xlow, xup);}
TH2* fillhist(const char* name, const char* title, Int_t size,
	      Double_t* valx, Int_t nbinsx, Double_t xlow, Double_t xup,
	      Double_t* valy, Int_t nbinsy, Double_t ylow, Double_t yup)
{return TNadekoSimpleFunction::CreateAndFillHist(name, title, size,
					      valx, nbinsx, xlow, xup,
					      valy, nbinsy, ylow, yup);}
TH3* fillhist(const char* name, const char* title, Int_t size,
	      Double_t* valx, Int_t nbinsx, Double_t xlow, Double_t xup,
	      Double_t* valy, Int_t nbinsy, Double_t ylow, Double_t yup,
	      Double_t* valz, Int_t nbinsz, Double_t zlow, Double_t zup)
{return TNadekoSimpleFunction::CreateAndFillHist(name, title, size,
					      valx, nbinsx, xlow, xup,
					      valy, nbinsy, ylow, yup,
					      valz, nbinsz, zlow, zup);}

void readobject(char* filename){TNadekoSimpleFunction::ReadObjectFromFile(filename);}
void writeobject(char* filename){TNadekoSimpleFunction::WriteObjectToFile(filename);}
void writehisttotext(char* filename){TNadekoSimpleFunction::WriteHistToText(filename);}
void createhist(char* filename){TNadekoSimpleFunction::CreateHistFromText(filename);}
void creategraph(char* filename){TNadekoSimpleFunction::CreateGraphFromText(filename);}
TH1* gethist(int id){return TNadekoHistManager::GetHist(id);}
void setoption(Option_t* option){TNadekoHistManager::SetDefaultOption(option);}
